#ifndef POMODORO_H
#define POMODORO_H

#include <stdint.h>
#include "esp32-hal-ledc.h"
#include "HardwareSerial.h"
#include "lib/pitches.h"

extern bool useLed;
extern bool useBuzzer;

extern uint32_t timeWork ;
extern uint32_t timeShortRest ;
extern uint32_t timeLongRest ;
extern int workBetweenLongBreak;
extern int workDone;
extern bool work;
extern int currentWait;
extern uint32_t timerLastValue;

extern const int pinLedWork;
extern const int pinLedShortBreak;
extern const int pinLedLongBreak;
extern const int ledFrequency;
extern const int ledResolution;
extern const int ledChannelWork;
extern const int ledChannelShortBreak;
extern const int ledChannelLongBreak;
extern int ledWorkMaxValue;
extern int ledShortBreakMaxValue;
extern int ledLongBreakMaxValue;

extern const int pinBuzzer;
extern const int buzzerFrequency;
extern const int buzzerResolution;
extern const int buzzerChannel;

void setupPomodoro();
void displayWork(bool);
void displayShortRest();
void displayLongRest();

#endif